//          Copyright Carl Philipp Reh 2009 - 2021.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#include <fcppt/text.hpp>
#include <fcppt/catch/begin.hpp>
#include <fcppt/catch/end.hpp>
#include <fcppt/filesystem/remove_extension.hpp>
#include <fcppt/config/external_begin.hpp>
#include <catch2/catch_test_macros.hpp>
#include <filesystem>
#include <fcppt/config/external_end.hpp>

FCPPT_CATCH_BEGIN
// NOLINTBEGIN(misc-const-correctness,cert-err58-cpp,fuchsia-statically-constructed-objects,misc-use-anonymous-namespace,cppcoreguidelines-avoid-do-while)

TEST_CASE("filesystem::remove_extension", "[filesystem]")
{
  std::filesystem::path const path1(
      std::filesystem::path(FCPPT_TEXT("foo")) / std::filesystem::path(FCPPT_TEXT("bar")));

  CHECK(path1 == fcppt::filesystem::remove_extension(path1));

  std::filesystem::path const path2(path1 / FCPPT_TEXT("baz.txt"));

  CHECK(fcppt::filesystem::remove_extension(path2) == path1 / FCPPT_TEXT("baz"));
}

// NOLINTEND(misc-const-correctness,cert-err58-cpp,fuchsia-statically-constructed-objects,misc-use-anonymous-namespace,cppcoreguidelines-avoid-do-while)
FCPPT_CATCH_END
