//          Copyright Carl Philipp Reh 2009 - 2021.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#include <fcppt/catch/begin.hpp>
#include <fcppt/catch/end.hpp>
#include <fcppt/math/box/comparison.hpp>
#include <fcppt/math/box/object_impl.hpp>
#include <fcppt/math/box/output.hpp> // NOLINT(misc-include-cleaner)
#include <fcppt/config/external_begin.hpp>
#include <catch2/catch_test_macros.hpp>
#include <fcppt/config/external_end.hpp>

FCPPT_CATCH_BEGIN
// NOLINTBEGIN(misc-const-correctness,cert-err58-cpp,fuchsia-statically-constructed-objects,misc-use-anonymous-namespace,cppcoreguidelines-avoid-do-while)

TEST_CASE("math::box comparison", "[math],[box]")
{
  using box_type = fcppt::math::box::object<int, 2>;

  CHECK(
      box_type(box_type::vector(1, 2), box_type::dim(3, 4)) ==
      box_type(box_type::vector(1, 2), box_type::dim(3, 4)));

  CHECK(
      box_type(box_type::vector(1, 2), box_type::dim(3, 4)) !=
      box_type(box_type::vector(5, 2), box_type::dim(3, 4)));

  CHECK(
      box_type(box_type::vector(1, 2), box_type::dim(3, 4)) <
      box_type(box_type::vector(5, 2), box_type::dim(3, 4)));
}

// NOLINTEND(misc-const-correctness,cert-err58-cpp,fuchsia-statically-constructed-objects,misc-use-anonymous-namespace,cppcoreguidelines-avoid-do-while)
FCPPT_CATCH_END
